'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = OptionListControlledInput;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PrefixFilteringDropdownMenuInput = require('./PrefixFilteringDropdownMenuInput');

var _PrefixFilteringDropdownMenuInput2 = _interopRequireDefault(_PrefixFilteringDropdownMenuInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = _extends({}, _PrefixFilteringDropdownMenuInput2.default.propTypes, {
  formatOptionLabel: _react.PropTypes.func,
  options: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    value: _react.PropTypes.string
  }))
});

var defaultProps = {
  formatOptionLabel: function formatOptionLabel(option) {
    return typeof option.label === 'undefined' ? option.value : option.label;
  },
  options: []
};

function OptionListControlledInput(props) {
  var formatOptionLabel = props.formatOptionLabel,
      options = props.options,
      remainingProps = _objectWithoutProperties(props, ['formatOptionLabel', 'options']);

  var labeledOptions = options.map(function (option) {
    return Object.assign({}, option, {
      label: formatOptionLabel(option)
    });
  });

  return _react2.default.createElement(_PrefixFilteringDropdownMenuInput2.default, _extends({}, remainingProps, {
    options: labeledOptions
  }));
}

OptionListControlledInput.propTypes = propTypes;
OptionListControlledInput.defaultProps = defaultProps;